/*!
  * Licensed Materials - Property of IBM
  * 5725N95, 5725P55, 5725N96
  * (C) Copyright IBM Corp. 1999, 2014.
  * US Government Users Restricted Rights- Use, duplication or disclosure
  * restricted by GSA ADP Schedule Contract with IBM Corp.
 */

 /* $Id$ */
 
function BaseViewer()
{
	this.studentID = "";
	this.themeID = "";
	this.studentRole = "";
	this.loStatus = "";
	this.inlineExternal = "false";
	this.docMode = "";
	this.subDocMode = "";
	this.viewName = "";
	this.loWidth = 800;
	this.loHeight = 600;
	this.popupWidth = 638;
	this.popupHeight = 480
	this.mediaWidth = 638;
	this.mediaHeight = 480;
	this.externalWidth = 800;
	this.externalHeight = 600;
    this.extWindowOptions = "location=no,menubar=no,scrollbars=yes,left=1,top=1,toolbar=no,status=no,resizable=yes";
    this.lowindowstyle = "scrollbars=yes,top=1,left=1,resizable=yes,menubar=no,toolbar=no";
	this.assessmentHeight = 600;
	this.assessmentWidth = 800;
	this.useCachedMedia = true;
	this.remoteMediaLoc = "";
	this.browser = getBrowser();
	this.servletPath = "";
	this.objectPages = new Array();
	this.timeoutID = "";

	this.globalRefObj = null;
	this.findGlobalRefObjTries = 0;
	this.searched = false;

    this.debug = false;

	return this;
}

BaseViewer.GLOBAL_REF_OBJ_NAME = "globalRefObj";
BaseViewer.MAX_FIND_GLOBAL_REF_OBJ_TRIES = 30;

function getBrowser()
{
  var b = navigator.appName;
  if (b.indexOf("Microsoft") > -1)
  {
  	return "Microsoft";
  }
  else if (b.indexOf("Netscape") > -1)
  {
  	return "Netscape";
  }
  else
  {
  	return "Other";
  }
}

BaseViewer.prototype.NewLO = function( id, usePopup, options)
{
	var url = OSDeliveryEngine.getURL(id);
	if (url != null)
	{
		if (usePopup == "0")
		{
			location.href = url;
		}
		else if (usePopup == null || usePopup == "" || usePopup == "1")
		{
			var windowNm = "LOWin";
			var opt = this.lowindowstyle+",width="+this.loWidth+",height="+this.loHeight;
			if(options) {
				opt = options;
				windowNm = null;
			}
			OSDeliveryEngine.launchWindow(url, windowNm, opt);
		} 
		else if(usePopup == "2")
		{
			de.launchDialog(url, options);
		}
		else
		{
			usePopup.location.href = url;
		}	
	}
}

BaseViewer.prototype.NewPage = function( id, usePopup, options )
{
	var url = OSDeliveryEngine.getURL(id);
	if (url != null)
	{
		if (usePopup == "0")
		{
			location.href = url;
		}
		else if (usePopup == null || usePopup == "1")
		{
			var windowNm = "TopicWin";
			var opt = "scrollbars=yes,width="+this.popupWidth+",height="+this.popupHeight +",top=1,left=1,resizable=yes";
			if(options) {
				opt = options;
				windowNm = null;
			}
			OSDeliveryEngine.launchWindow(url, windowNm, opt);
		}
		else if(usePopup == "2")
		{
			de.launchDialog(url, options);
		}
		else
		{
			usePopup.location.href = url;
		}
	}
}

BaseViewer.prototype.NewGrouping = function( id, usePopup, options )
{
	var url = OSDeliveryEngine.getURL(id);
	if (url != null)
	{
		if (usePopup == "0")
		{
			location.href = url;
		}
		else if (usePopup == null || usePopup == "1")
		{
			var windowNm = "GroupWin";
			var opt = "scrollbars=yes,width="+this.popupWidth+",height="+this.popupHeight +",top=1,left=1,resizable=yes";
			if(options) {
				opt = options;
				windowNm = null;
			}
			OSDeliveryEngine.launchWindow(url, windowNm, opt);
		}
		else if(usePopup == "2")
		{
			de.launchDialog(url, options);
		}
		else
		{
			usePopup.location.href = url;
		}
	}
}

BaseViewer.prototype.NewContent = function( id, usePopup, options )
{
	var url = OSDeliveryEngine.getURL(id);
	if (url != null)
	{
		if (usePopup == "0")
		{
			location.href = url;
		}
		else if (usePopup == null || usePopup == "1")
		{
			var windowNm = "ContentWin";
			var opt = "scrollbars=yes,width="+this.popupWidth+",height="+this.popupHeight +",top=1,left=1,resizable=yes";
			if(options) {
				opt = options;
				windowNm = null;
			}
			OSDeliveryEngine.launchWindow(url, windowNm, opt);
		}
		else if(usePopup == "2")
		{
			de.launchDialog(url, options);
		}
		else
		{
			usePopup.location.href = url;
		}
	}
}

BaseViewer.prototype.NewSurvey = function( id, usePopup, options )
{
	var url = OSDeliveryEngine.getURL(id);
	if (url != null)
	{
		if (usePopup == "0")
		{
			location.href = url;
		}
		else if (usePopup == null || usePopup == "1")
		{
			var windowNm = "SurveyWin";
			var opt = "scrollbars=yes,width="+this.loWidth+",height="+this.loHeight +",top=1,left=1,resizable=no";
			if(options) {
				opt = options;
				windowNm = null;
			}
			OSDeliveryEngine.launchWindow(url, windowNm, opt);
		}
		else if(usePopup == "2")
		{
			de.launchDialog(url, options);
		}
		else
		{
			usePopup.location.href = url;
		}
	}
}

BaseViewer.prototype.NewPrescription = function( assessID, studentAssessID, objectID, objectTypeID, level, courseID, doModal)
{
	submitWindowHandle = "AssessmentPrescription?themeID="+this.themeID+"&studentID="+this.studentID+"&assessID="+assessID+"&objectID="+objectID+"&studentAssessID="+studentAssessID+"&objectTypeID="+objectTypeID+"&level="+level+"&courseID="+courseID+"&doModal="+doModal;

	if (doModal == "true") {
		// this method is only used in the LO viewer for launching the assessment in a simulated modal window
		submitWindowHandle += "&calledFrom=viewer";
		parent.openDGDialog(submitWindowHandle, this.assessmentWidth, this.assessmentHeight, "");
		return false;
	} else {
		window.open(submitWindowHandle ,assessID,"height="+this.assessmentHeight+",width="+this.assessmentWidth+",location=no,menubar=no,scrollbars=yes,left=0,top=0,toolbar=no,status=no,resizable=no");
	}
}

BaseViewer.prototype.NewAssessment = function( id, usePopup, options, level, courseID, doModal, doInline)
{
	var url = OSDeliveryEngine.getURL(id);
	if (url != null)
	{
		if (usePopup == "0")
		{
			location.href = url;
		}
		else if (usePopup == "1")
		{
			var windowNm = "AssessmentWin";
			var opt = "scrollbars=yes,"+"width="+this.assessmentWidth+",height="+this.assessmentHeight +",top=1,left=1,resizable=no";
			if(options) {
				opt = options;
				windowNm = null;
			}
			OSDeliveryEngine.launchWindow(url, windowNm, opt);
		} 
		else if(usePopup == "2")
		{
			de.launchDialog(url, options);
		}
		else {
			// Hoang - #22318: modified to support launching inline assessment.
			if ( doInline == "true" || this.docMode == "HELP" || this.subDocMode == "chm" )
			{
				location.href = url;
			}
			else
			{
				// Hoang - #22586: fixed modal assessment problem in CBT Viewer.
				if (doModal == "true")
				{
					// this method is only used in the LO viewer for launching the assessment in a simulated modal window
					parent.openDGDialog(url, this.assessmentWidth, this.assessmentHeight, "");
					return false;
				}
				else
				{
					submitWindowHandle = window.open(url,"AssessmentWin","scrollbars=yes,"+"width="+this.assessmentWidth+",height="+this.assessmentHeight +",top=1,left=1,resizable=no");
				}
	
				if ( this.viewName == "CbtView" )
				{
					if (doModal == "true")
					{
						// this method is only used in the LO viewer for launching the assessment in a simulated modal window
						parent.openDGDialog(url, this.assessmentWidth, this.assessmentHeight, "");
						return false;
					}
					else
					{
						submitWindowHandle = window.open(url,"AssessmentWin","scrollbars=yes,width="+this.assessmentWidth+",height="+this.assessmentHeight +",top=1,left=1,resizable=yes");
					}
				}
	
				if (submitWindowHandle.opener == null) submitWindowHandle.opener = window;
				submitWindowHandle.focus();
			}
		}
	}
}
// Hoang - #22307: added to fix navigation problem with group tabs.
BaseViewer.prototype.jumpToGroup = function( id, groupTypeID, doLinearNav )
{
	if (parent.frames.menu) {
		// In linear navigation, do not let it access the group if it is not enabled yet.
		var okToAccess = (doLinearNav == "1" ? parent.frames.menu.isEnabled("0", "0", "0", id) : true );
		if (okToAccess) {
			parent.frames.menu.ChangeGroupID(id);
		}
	} else {
		// If menu frames is not available (when viewed or exported at topic level), launch the group using the local function.
		// Binh Tong, 09/30/2009, #28088
		var url = URLMap[id];
		if (url != null)
		{
			location.href = url;
		}
	}
}
BaseViewer.prototype.launchGroupLnk = function( urlstring )
{
	location.href = urlstring;
}
BaseViewer.prototype.NewExternalContent = function( id, usePopup, options )
{
	var url = OSDeliveryEngine.getURL(id);
	if (url != null)
	{
		if (usePopup == "0")
		{
			location.href = url;
		}
		else if (usePopup == null || usePopup == "1")
		{
			var windowNm = "ExternalWin";
			var opt = "width="+this.externalWidth+",height="+this.externalHeight +","+this.extWindowOptions;
			if(options) {
				opt = options;
				windowNm = null;
			}
			OSDeliveryEngine.launchWindow(url, windowNm, opt);
		}
		else if(usePopup == "2")
		{
			de.launchDialog(url, options);
		}
		else
		{
			usePopup.location.href = url;
		}
	}
}
BaseViewer.prototype.NewExternalContainer = function(id, usePopup, options)
{
	var url = OSDeliveryEngine.getURL(id);
	if (url != null)
	{
		if (usePopup == "0")
		{
			location.href = url;
		}
		else if (usePopup == null || usePopup == "1")
		{
			var windowNm = "ExternalWin";
			var opt = "width="+this.externalWidth+",height="+this.externalHeight +","+this.extWindowOptions;
			if(options) {
				opt = options;
				windowNm = null;
			}
			OSDeliveryEngine.launchWindow(url, windowNm, opt);
		}
		else if(usePopup == "2")
		{
			de.launchDialog(url, options);
		}
		else
		{
			usePopup.location.href = url;
		}
	}
}

// new method for launching SoftSim Assessment content type
BaseViewer.prototype.NewSimContent = function( id, contentID, instanceID, openSettings, playMode )
{
	if (id == null || id == "") {
		alert(getMessage().msg_addsimulation);
		return;
	} else {
		// container servlet doesn't provide logging for access history
		var url = OSDeliveryEngine.getURL(id);
		if (playMode != null && playMode != "") url += "&playMode=" + playMode;
		if (url != null)
		{			
			OSDeliveryEngine.launchWindow(url,"SimViewerWin","width="+this.externalWidth+",height="+this.externalHeight +","+this.extWindowOptions);			
		}
	}
	return;
}

// new method for launching CMI detail score page
BaseViewer.prototype.NewCMIDetail = function( instanceID, contentID, stem, bExported )
{
	// container servlet doesn't provide logging for access history
		var url = "viewscoredetail.html?instanceID=" + instanceID +
				  "&contendID="+contentID +
				  "&themeID=" + this.themeID +
				  "&stemText=" + stem +
				  "&exported=" + bExported;

		// container servlet doesn't provide logging for access history
			var args = "?instanceID=" + instanceID +
					  "&contendID="+contentID +
					  "&themeID=" + this.themeID +
					  "&stemText=" + stem +
					  "&exported=" + bExported;

		var fname = this.getReference("viewscoredetail.html");

		if ( fname != null ) {
			url = fname;
		}
		url = url+args;

		simViewerWin = window.open(url,"simViewerWin","scrollbars=yes,"+
			"width="+this.externalWidth+",height="+this.externalHeight +",top=1,left=1,resizable=yes");
		if (simViewerWin.opener == null) simViewerWin.opener = window;
		simViewerWin.focus();


	return;
}

BaseViewer.prototype.LaunchExport = function( objectID )
{
    	var url = "LaunchCachedZip?objectID=" + objectID +
    		      	"&docMode=" + this.docMode +
    			"&browser=" + this.browser +
    		      	"&studentID=" + this.studentID +
    			"&themeID="+this.themeID+
    			"&studentRole="+this.studentRole+
    			"&loStatus="+this.loStatus;

	if ( this.docMode == "HELP" || this.subDocMode == "chm")
	{
		location.href = url;
	}
	else
	{
		popup = window.open(url,"CachedZip","scrollbars=no,"+
				"width="+400+",height="+300 +",top=1,left=1,resizable=yes");
		if (popup.opener == null) popup.opener = window;
		popup.focus();
	}
	return;
}

BaseViewer.prototype.NewMedia = function(id,usePopup, options)
{
	var url = OSDeliveryEngine.getURL(id);
	if (url != null)
	{
		if (usePopup == "0")
		{
			location.href = url;
		}
		else if (usePopup == null || usePopup == "1")
		{
			var windowNm = "MediaWin";
			var opt = "scrollbars=yes,width="+this.mediaWidth+",height="+this.mediaHeight +",top=1,left=1,resizable=yes";
			if(options) {
				opt = options;
				windowNm = null;
			}
			OSDeliveryEngine.launchWindow(url, windowNm, opt);
		}
		else if(usePopup == "2")
		{
			de.launchDialog(url, options);
		}
		else
		{
			usePopup.location.href = url;
		}
	}
}

BaseViewer.prototype.OpenWindow = function(newin,windowname)
{
	newin = "http://www.tra.com/outstart/lexicat/newin";
	window.open(newin, windowname, "resizable=yes,scrollbars=yes,width=500,height=300,top=15,left=15,location=0,directories=0,menubar=0,toolbar=0");
}

BaseViewer.prototype.LaunchExport = function(objectID)
{
	url = "LaunchCachedZip?studentID=" + this.studentID + "&objectID=" + objectID;
      popup = window.open(url, "CachedZip","scrollbars=no, width=400,height=300,top=1,left=1,resizable=yes");
      if (popup.opener == null) popup.opener = window;
      popup.focus();
}


/*
 * Validate GUID Format. This routine will return true if the passed in argument is in a valid GUID format. False, otherwise.
 * This preliminary test pre-validates the GUID before using up server and database resources to lookup the GUID
 */
function isValidGuidFormat(id)
{
	var GUID_LENGTH = 32;

    //Check for valid length.
    if (id == null) { return false; }
    if (id.length != GUID_LENGTH) { return false; }

    // Check for valid characters.
    for ( i = 0; i < GUID_LENGTH; i++) {
        var c = id.charAt(i);
        if (c != '0' && c != '1' && c != '2' && c != '3' && c != '4' &&
            c != '5' && c != '6' && c != '7' && c != '8' && c != '9' &&
            c != 'a' && c != 'b' && c != 'c' && c != 'd' && c != 'e' && c != 'f' &&
            c != 'A' && c != 'B' && c != 'C' && c != 'D' && c != 'E' && c != 'F') {
            alert( "Invalid GUID format." );
            return false;
        }
    }
    return true;
}