/*!
  * Licensed Materials - Property of IBM
  * 5725N95, 5725P55, 5725N96
  * (C) Copyright IBM Corp. 1999, 2014.
  * US Government Users Restricted Rights- Use, duplication or disclosure
  * restricted by GSA ADP Schedule Contract with IBM Corp.
 */

 /* $Id$ */
 
function formatScore(score)
{
    return formatTwoDecimal(score);
}

showReport = function(type, args, me)
{
	showAssessmentSummary(args[0]);
}

AssessmentEngine.events.scoreComplete.subscribe(showReport)

/**
 * Generates the score of the specified assessment and displays it's
 * summary in an HTML page
 */
function showAssessmentSummary(assessment)
{
    var summary =   "<table cellspacing='0' width='100%' border='0' cellpadding='10' bgcolor='#FFFFFF'>\n"+
                    "  <tr>\n"+
                    "    <td class='ad-detailheaderstyle'><img src='"+ASSESSMENT_RESULTS_LOGO+"'/></td>\n"+
                    "    <td width='100%' class='ad-detailheaderstyle'><span class='ad-detailheaderstyle'>" + unescape(assessment.getLabel()) + "</span></td>\n"+
                    "  </tr>\n"+
                    "</table>\n";

    summary += "<table border=0 width='100%' bgcolor='#000000' cellpadding=3 cellspacing=1>\n";
    summary += "<tr><td width='40%' class='ad-bodystyle'>&nbsp;</td><td class='ad-bodystyle' colspan=6 align=center><span class='ad-scoreheaderstyle'>Scores<span></td></tr>\n"
    summary += "<tr><td width='40%' class='ad-bodystyle'>&nbsp;</td><td class='ad-statusstyle'><table width=100%><tr><td align=left width='33%'><span class='ad-statusstyle'>0</span></td><td align=center width='34%'><span class='ad-statusstyle'>50</span></td><td align=right width='33%'><span class='ad-statusstyle'>100<span></td></tr></table></td><td class='ad-statusstyle' colspan=2 align=center><span class='ad-statusstyle'>Raw</span></td><td class='ad-statusstyle' colspan=3 align=center><span class='ad-statusstyle'>Weighted<span></td></tr>\n";
    summary += "<tr><td width='40%' class='ad-bodystyle'>&nbsp;</td><td class='ad-bodystyle'>&nbsp;</td><td class='ad-bodystyle' align=center><span class='ad-actposstyle'>Actual</span></td><td class='ad-bodystyle' align=center><span class='ad-actposstyle'>Possible</span></td><td class='ad-bodystyle' align=center><span class='ad-actposstyle'>Actual</span></td><td class='ad-bodystyle' align=center><span class='ad-actposstyle'>Possible</span></td><td class='ad-bodystyle' align=center>%</td></tr>\n";

    summary += "<tr><td colspan=7 class='ad-assesstitlestyle'>" + unescape(assessment.getLabel()) + "</td></tr>\n";
	
    // iterate thru all sections in the assessment
    var sections = assessment.children;
    var count = 0;
    var sumSWA = 0;
    var sumSWP = 0;

    for(var j=0; j<sections.length; j++)
    {
        var section = sections[j];
        summary += "<tr><td class='ad-sectiontitlestyle' colspan=7><span class='ad-sectiontitlestyle'>&nbsp;&nbsp;&nbsp;" + unescape(section.getLabel()) + "</span></td></tr>\n";

        // iterate thru all questions in the sections
        var questions = section.children;
        for(var k=0; k<questions.length; k++)
        {
            count++;
            var question = questions[k];
            var score = question.getScore();
            var raw_actual = Math.max(0, score.getTotalCorrect() - score.getTotalIncorrect());
            var raw_possible = score.getQuestionValue();
            var weighted_actual = raw_actual * question.getWeight();
            var weighted_possible = raw_possible * question.getWeight();
            var weighted_percent = raw_actual / raw_possible * 100;
            var width_percent     = (1.2)* weighted_percent;
            var section_percent   = (1.2)*(section.getScore() * 100);
            var assessment_percent= (1.2)*(assessment.getScore() * 100);

			var contentStem = unescape(question.getStem());
			if (question.type == "109") {
				// this is for viewing CMI details
				contentStem = "<a target=cmidetail href=\"\" onClick=\"javascript:NewCMIDetail('"+question.getContentID()+"', '"+question.getContentID()+"', '"+ contentStem+"', 'true');return false;\" >"+contentStem+"</a>";
			}
 			if (question.type == "103")
           			 weighted_actual = weighted_actual / weighted_possible;

            summary += "<tr><td class='ad-bodystyle'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<span class='ad-contentdescstyle'>" + (count) + ") " + contentStem + "</span></td>";
            summary += "<td class='ad-bodystyle' width='120.0'><div width='100%' class='yellowimgdiv'><img src='"+QUESTION_TOTAL_RESULTS_GRAPH_IMAGE+"' height=10 width='" + width_percent + "px' alt='" + formatScore(weighted_percent) + "%' title='" + formatScore(weighted_percent) + "%'></div></td>\n";
            summary += "<td class='ad-bodystyle' align=right><span class='ad-contentdescstyle'>" + formatScore(raw_actual) + "</span></td>";
            summary += "<td class='ad-bodystyle' align=right><span class='ad-contentdescstyle'>" + formatScore(raw_possible) + "</span></td>";
            summary += "<td class='ad-bodystyle' align=right><span class='ad-contentdescstyle'>" + formatScore(weighted_actual) + "</span></td>";
            summary += "<td class='ad-bodystyle' align=right><span class='ad-contentdescstyle'>" + formatScore(weighted_possible) + "</span></td>";
            summary += "<td class='ad-bodystyle' align=right><span class='ad-contentdescstyle'>" + formatScore(weighted_percent) + "%</span></td>";
            summary += "</tr>\n";
        }

        // section total
        summary += "<tr><td class='ad-sectiontitlestyle'><span class='ad-sectiontitlestyle'>&nbsp;&nbsp;&nbsp;Total</span></td>";
        summary += "<td class='ad-sectiontitlestyle' width='120.0'><div width='100%' class='blueimgdiv'><img src='"+SECTION_TOTAL_RESULTS_GRAPH_IMAGE+"' height=10 width='" + section_percent  + "px' alt='" + formatScore(section.getScore() * 100) + "%' title='" + formatScore(section.getScore() * 100) + "%'></div></td>\n";
        summary += "<td class='ad-sectiontitlestyle'>&nbsp;</td>";
        summary += "<td class='ad-sectiontitlestyle'>&nbsp;</td>";
        summary += "<td class='ad-sectiontitlestyle' align=right><span class='ad-sectiontitlestyle'>" + formatScore(section.getScore() * section.getWeight()) + "</span></td>";
        summary += "<td class='ad-sectiontitlestyle' align=right><span class='ad-sectiontitlestyle'>" + formatScore(section.getWeight()) + "</span></td>";
        summary += "<td class='ad-sectiontitlestyle' align=right><span class='ad-sectiontitlestyle'>" + formatScore(section.getScore() * 100) + "%</span></td>";
        summary += "</tr>\n";

        // blank row
        summary += "<tr><td class='ad-bodystyle' colspan=7>&nbsp;</td></tr>";

        sumSWA += section.getScore() * section.getWeight();
        sumSWP += section.getWeight();
    }

    // assessment total
    summary += "<tr><td class='ad-assesstitlestyle'>Total</td>";
    summary += "<td class='ad-assesstitlestyle' width='120.0'><div width='100%' class='tealimgdiv'><img src='"+ASSESSMENT_TOTAL_RESULTS_GRAPH_IMAGE+"' height=10 width='" + assessment_percent  + "px' alt='" + formatScore(assessment.getScore() * 100) + "%' title='" + formatScore(assessment.getScore() * 100) + "%'></div></td>\n";
    summary += "<td class='ad-assesstitlestyle'>&nbsp;</td>";
    summary += "<td class='ad-assesstitlestyle'>&nbsp;</td>";
    summary += "<td class='ad-assesstitlestyle' align=right>" + formatScore(sumSWA) + "</td>";
    summary += "<td class='ad-assesstitlestyle' align=right>" + formatScore(sumSWP) + "</td>";
    summary += "<td class='ad-assesstitlestyle' align=right>" + formatScore(assessment.getScore() * 100) + "%</td>";
    summary += "</tr>\n";

    summary += "</table>\n";

	summary += "<BR><BR><form><div align=center><input type=submit value='Close' onClick='var w=window,i=0;while(i++<20){w.close();if(w==w.parent)break;w=w.parent}return false;'></div></form>\n";
    if(document.layers)
    {
		for ( var i=0;i<document.layers.length;i++)
		{
			document.layers[i].visibility='hide';
		}
		document.layers['scoresummarydiv'].zIndex='500';
		document.layers['scoresummarydiv'].visibility='show';
		document.layers['scoresummarydiv'].document.open();
		document.layers['scoresummarydiv'].document.writeln(summary);
		document.layers['scoresummarydiv'].document.close();
    }
	else
    {
        var divArray = document.getElementsByTagName("DIV");
        for (var i=0; i<divArray.length; i++)
        {
			divArray[i].style.visibility="hidden";
        }
        document.getElementById('scoresummarydiv').style.visibility='visible';
        document.getElementById('scoresummarydiv').style.zIndex  ='500';
        document.getElementById('scoresummarydiv').innerHTML = summary;
    }
}